<html>
	<head>
		<title>M2GPI</title>
	</head>
	<body>
		<form method="POST" action="fibonacci.php">
			<input type="submit" name="calcul" value="Calculer"/>
			le fibonacci de <input type="number" name="input"/> ?
		</form>
		<?php
			function iterativeFibonacci($count) {
				$fibonacci = array(0,1);
				for ($index=2; $index <= $count; $index++) { 
					$fibonacci[$index] = $fibonacci[$index-1] + $fibonacci[$index-2];
				}
				return $fibonacci[$count];
			}

			function recursiveFibonacci($count) {
				if ($count == 0) {
					return 0;
				} elseif ($count == 1) {
					return 1;
				} else {
					return (recursiveFibonacci($count - 1) + recursiveFibonacci($count - 2));
				}
			}
			if (isset($_POST['calcul']) && $_POST['input']) {

				echo "<h3>Fonction itérative</h3>";
				$start_time = microtime(true);
				echo "<p>L'occurence n°" . $_POST['input'] . " de la suite de fibonacci est " . iterativeFibonacci($_POST['input']) . "</p>";
				echo "<p>Le temps d'exécution est de " . number_format((microtime(true) - $start_time), 6) . " seconde(s)";

				echo "<h3>Fonction récursive</h3>";
				$start_time = microtime(true);
				echo "<p>L'occurence n°" . $_POST['input'] . " de la suite de fibonacci est " . recursiveFibonacci($_POST['input']) . "</p>";
				echo "<p>Le temps d'exécution est de " . number_format((microtime(true) - $start_time), 6) . " seconde(s)";

			} else {
				echo "<p>Veuillez fournir un nombre à évaluer.</p>";
			}
		?>
		<table>
			<tr>
				<th>Fibonacci</th>
				<th>Itératif</th>
				<th>Récursif</th>
			</tr>
			<?php
				for ($i=0; $i < 35; $i++) {
					$start_time = microtime(true);
					echo "<tr><td>" . iterativeFibonacci($i) . "</td>";
					echo "<td>" . number_format((microtime(true) - $start_time), 6) . "s</td>";
					$start_time = microtime(true);
					recursiveFibonacci($i);
					echo "<td>" . number_format((microtime(true) - $start_time), 6) . "s</td></tr>";
				}
			?>
		</table>
	</body>
</html>
