<?php
    foreach (glob("./classes/*.php") as $class) {
        require_once $class;
    }
?>
<html>
    <head>
        <title>M2GPI</title>
    </head>
    <body>
        <h1>M2GPI2024 Algorithmie</h1>
        <p>Count word occurences in a file.</p>
        <form enctype="multipart/form-data" method="POST" action="./index.php">
            <fieldset>
                <legend>Order results by</legend>
                <input type="radio" id="sortingModeOccurences" name="sortingMode" value="0" checked></input>
                <label for="sortingModeOccurences">occurences</label>
                <input type="radio" id="sortingModeWords" name="sortingMode" value="1"></input>
                <label for="sortingModeWords">words</label>
            </fieldset><br>
            <input type="hidden" name="MAX_FILE_SIZE" value="1000000"/>
            <input type="file" name="file"/><br>
            <input type="submit" name="upload" value="Submit file"/>
		</form>
        <?php
            try {
                if (isset($_POST['upload'])) {
                    $upload = "./uploads/". basename($_FILES['file']['name']);
                    if (move_uploaded_file($_FILES['file']['tmp_name'], $upload)) {
                        echo "<table><tr><th>Mots</th><th>Occurences</th></tr>";
                        $file = new MySplFileObject($upload, "r", boolval($_POST["sortingMode"]));
                        foreach ($file->getWords() as $word => $count) { 
                            echo "<tr><td>" . $word . "</td><td>" . $count . "</td></tr>";
                        }
                        echo "</table>";
                    }
                }
            } catch (Exception $e) {
                echo "Error : " . $e->getMessage();
            }
        ?>
    </body>
</html>